PhysicsWorld QML Type | Qt Quick 3D Physics | Qt 6.10.0
Description: Controls the physics simulation.

- Qt 6.10
- Qt Quick 3D Physics
- QML Types
- PhysicsWorld
- Qt Quick 3D Physics | Commercial or GPLv3

# PhysicsWorld QML Type

Controls the physics simulation. More...

Import Statement: | `import QtQuick3D.Physics`
Since: | Qt 6.4

- List of all members, including inherited members

## Properties

- defaultDensity : real
- enableCCD : bool
- forceDebugDraw : bool
- gravity : vector3d
- maximumTimestep : real
- minimumTimestep : real
- numThreads : int `(since 6.7)`
- reportKinematicKinematicCollisions : bool `(since 6.7)`
- reportStaticKinematicCollisions : bool `(since 6.7)`
- running : bool
- scene : Node
- typicalLength : real
- typicalSpeed : real
- viewport : Node

## Signals

- frameDone(float timestep) `(since 6.5)`

## Detailed Description

The PhysicsWorld type controls the physics simulation. This node is used to create an instance of the physics world as well as define its properties. There can only be one physics world. All collision nodes in the qml will get added automatically to the physics world.

## Property Documentation

defaultDensity : real

This property defines the default density of dynamic objects, measured in kilograms per cubic unit. This is equal to the weight of a cube with side `1`.

The default value is `0.001`, corresponding to 1 g/cm³: the density of water. If your unit of measurement is meters, a good value would be `1000`. Note that only positive values are allowed.

Range: `(0, inf]`

enableCCD : bool

This property enables continuous collision detection. This will reduce the risk of bodies going through other bodies at high velocities (also known as tunnelling). The default value is `false`.

Warning: Using trigger bodies with CCD enabled is not supported and can result in missing or false trigger reports.

forceDebugDraw : bool

This property enables debug drawing of all active shapes in the physics world. The default value is `false`.

gravity : vector3d

This property defines the gravity vector of the physics world. The default value is `(0, -981, 0)`. Set the value to `Qt.vector3d(0, -9.81, 0)` if your unit of measurement is meters and you are simulating Earth gravity.

maximumTimestep : real

This property defines the maximum simulation timestep in milliseconds. The default value is `33.333`.

Range: `[0, inf]`

Note: The simulation timestep works in lockstep with the rendering, meaning a new simulation frame will only be started after a rendered frame has completed. This means that at most one simulation frame will run per rendered frame.

minimumTimestep : real

This property defines the minimum simulation timestep in milliseconds. The default value is `1`.

Range: `[0, maximumTimestep]`

Note: The simulation timestep works in lockstep with the rendering, meaning a new simulation frame will only be started after a rendered frame has completed. This means that at most one simulation frame will run per rendered frame.

numThreads : int `[since 6.7]`

This property defines the number of threads used for the physical simulation. This is how the range of values are interpreted:

Value | Range | Description
--- | --- | ---
Negative | `[-inf, -1]` | Automatic thread count. The application will try to query the number of threads from the system.
Zero | `{0}` | No threading, simulation will run sequentially.
Positive | `[1, inf]` | Specific thread count.

The default value is `-1`, meaning automatic thread count.

Note: Once the scene has started running it is not possible to change the number of threads.

This property was introduced in Qt 6.7.

reportKinematicKinematicCollisions : bool `[since 6.7]`

This property controls if collisions between pairs of kinematic dynamic rigid bodies will trigger a contact report.

The default value is `false`.

Note: Once the scene has started running it is not possible to change this setting.

This property was introduced in Qt 6.7.

See also PhysicsWorld::reportStaticKinematicCollisions, DynamicRigidBody, and PhysicsNode::bodyContact.

reportStaticKinematicCollisions : bool `[since 6.7]`

This property controls if collisions between a static rigid body and a kinematic dynamic rigid body will trigger a contact report.

The default value is `false`.

Note: Once the scene has started running it is not possible to change this setting.

This property was introduced in Qt 6.7.

See also PhysicsWorld::reportKinematicKinematicCollisions, StaticRigidBody, DynamicRigidBody, and PhysicsNode::bodyContact.

running : bool

This property starts or stops the physical simulation. The default value is `true`.

scene : Node

This property defines the top-most Node that contains all the nodes of the physical simulation. All physics objects that are an ancestor of this node will be seen as part of this PhysicsWorld.

Note: Using the same scene node for several PhysicsWorld is unsupported.

typicalLength : real

This property defines the approximate size of objects in the simulation. This is used to estimate certain length-related tolerances. Objects much smaller or much larger than this size may not behave properly. The default value is `100`.

Range: `[0, inf]`

typicalSpeed : real

This property defines the typical magnitude of velocities of objects in simulation. This is used to estimate whether a contact should be treated as bouncing or resting based on its impact velocity, and a kinetic energy threshold below which the simulation may put objects to sleep.

For normal physical environments, a good choice is the approximate speed of an object falling under gravity for one second. The default value is `1000`.

Range: `[0, inf]`

viewport : Node

This property defines the viewport where debug components will be drawn if forceDebugDraw is enabled. If unset the scene node will be used.

See also forceDebugDraw and scene.

## Signal Documentation

`[since 6.5]` frameDone(float timestep)

This signal is emitted when the physical simulation is done simulating a frame. The timestep parameter is how long in milliseconds the timestep was in the simulation.

Note: The corresponding handler is `onFrameDone`.

This signal was introduced in Qt 6.5.